package dev.shadowsoffire.apotheosis.adventure.affix;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixRegistry;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import java.util.Map;
import java.util.function.BiConsumer;
import javax.annotation.Nullable;
import net.minecraft.ChatFormatting;
import net.minecraft.core.BlockPos;
import net.minecraft.network.chat.CommonComponents;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.MobType;
import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.context.UseOnContext;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.phys.HitResult;

public abstract class Affix implements CodecProvider<Affix> {
  protected final AffixType type;
  
  public Affix(AffixType type) {
    this.type = type;
  }
  
  public void addModifiers(ItemStack stack, LootRarity rarity, float level, EquipmentSlot type, BiConsumer<Attribute, AttributeModifier> map) {}
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix." + getId() + ".desc", new Object[] { fmt(level) });
  }
  
  public Component getName(boolean prefix) {
    if (prefix)
      return (Component)Component.m_237115_("affix." + getId()); 
    return (Component)Component.m_237115_("affix." + getId() + ".suffix");
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    return (Component)getDescription(stack, rarity, level);
  }
  
  public int getDamageProtection(ItemStack stack, LootRarity rarity, float level, DamageSource source) {
    return 0;
  }
  
  public float getDamageBonus(ItemStack stack, LootRarity rarity, float level, MobType creatureType) {
    return 0.0F;
  }
  
  public void doPostAttack(ItemStack stack, LootRarity rarity, float level, LivingEntity user, @Nullable Entity target) {}
  
  public void doPostHurt(ItemStack stack, LootRarity rarity, float level, LivingEntity user, @Nullable Entity attacker) {}
  
  public void onArrowFired(ItemStack stack, LootRarity rarity, float level, LivingEntity user, AbstractArrow arrow) {}
  
  @Nullable
  public InteractionResult onItemUse(ItemStack stack, LootRarity rarity, float level, UseOnContext ctx) {
    return null;
  }
  
  public void onArrowImpact(AbstractArrow arrow, LootRarity rarity, float level, HitResult res, HitResult.Type type) {}
  
  public float onShieldBlock(ItemStack stack, LootRarity rarity, float level, LivingEntity entity, DamageSource source, float amount) {
    return amount;
  }
  
  public void onBlockBreak(ItemStack stack, LootRarity rarity, float level, Player player, LevelAccessor world, BlockPos pos, BlockState state) {}
  
  public float getDurabilityBonusPercentage(ItemStack stack, LootRarity rarity, float level, @Nullable ServerPlayer user) {
    return 0.0F;
  }
  
  public float onHurt(ItemStack stack, LootRarity rarity, float level, DamageSource src, LivingEntity ent, float amount) {
    return amount;
  }
  
  public boolean enablesTelepathy() {
    return false;
  }
  
  public void getEnchantmentLevels(ItemStack stack, LootRarity rarity, float level, Map<Enchantment, Integer> enchantments) {}
  
  public void modifyLoot(ItemStack stack, LootRarity rarity, float level, ObjectArrayList<ItemStack> loot, LootContext ctx) {}
  
  public String toString() {
    return String.format("Affix: %s", new Object[] { getId() });
  }
  
  public AffixType getType() {
    return this.type;
  }
  
  public abstract boolean canApplyTo(ItemStack paramItemStack, LootCategory paramLootCategory, LootRarity paramLootRarity);
  
  public static boolean isOnCooldown(ResourceLocation id, int cooldown, LivingEntity entity) {
    long lastApplied = entity.getPersistentData().m_128454_("apoth.affix_cooldown." + id.toString());
    return (lastApplied != 0L && lastApplied + cooldown >= entity.m_9236_().m_46467_());
  }
  
  public static void startCooldown(ResourceLocation id, LivingEntity entity) {
    entity.getPersistentData().m_128356_("apoth.affix_cooldown." + id.toString(), entity.m_9236_().m_46467_());
  }
  
  public static String fmt(float f) {
    if (f == (float)(long)f)
      return String.format("%d", new Object[] { Long.valueOf((long)f) }); 
    return ItemStack.f_41584_.format(f);
  }
  
  public static MutableComponent valueBounds(Component min, Component max) {
    return CommonComponents.m_264333_().m_7220_((Component)Component.m_237110_("misc.apotheosis.affix_bounds", new Object[] { min, max }).m_130940_(ChatFormatting.DARK_GRAY));
  }
  
  public final ResourceLocation getId() {
    return AffixRegistry.INSTANCE.getKey(this);
  }
}
